#amqp #rabbitmq #futures #tokio #tls

lapin-futures-openssl

Integration of openssl with lapin-futures

15 releases (9 breaking)

✓ Uses Rust 2018 edition

0.10.1 Mar 11, 2020
0.10.0 Mar 3, 2019
0.9.0 Feb 15, 2019
0.6.1 Dec 5, 2018
0.4.0 Jul 9, 2018

#650 in Network programming

Download history 34/week @ 2019-11-29 334/week @ 2019-12-06 1/week @ 2019-12-13 16/week @ 2019-12-27 210/week @ 2020-01-10 104/week @ 2020-01-17 2/week @ 2020-01-31 22/week @ 2020-02-07 31/week @ 2020-02-14 53/week @ 2020-02-21 25/week @ 2020-02-28 42/week @ 2020-03-06 26/week @ 2020-03-13

166 downloads per month

BSD-2-Clause

33KB
256 lines

DEPRECATED, use lapin directly instead


lib.rs:

lapin-futures-openssl

This library offers a nice integration of openssl with the lapin-futures library. It uses amq-protocol URI parsing feature and adds the connect and connect_cancellable methods to AMQPUri which will provide you with a lapin_futures::client::Client and optionally a lapin_futures::client::HeartbeatHandle wrapped in a Future.

It autodetects whether you're using amqp or amqps and opens either a raw TcpStream or a SslStream using openssl as the SSL engine.

Connecting and opening a channel

use env_logger;
use failure::Error;
use futures::future::Future;
use lapin_futures_openssl::{AMQPConnectionOpensslExt, lapin};
use lapin::channel::ConfirmSelectOptions;
use tokio;

fn main() {
    env_logger::init();

    tokio::run(
        "amqps://user:pass@host/vhost?heartbeat=10".connect_cancellable(|err| {
            eprintln!("heartbeat error: {:?}", err);
        }).map_err(Error::from).and_then(|(client, heartbeat_handle)| {
            println!("Connected!");
            client.create_confirm_channel(ConfirmSelectOptions::default()).map(|channel| (channel, heartbeat_handle)).and_then(|(channel, heartbeat_handle)| {
                println!("Stopping heartbeat.");
                heartbeat_handle.stop();
                println!("Closing channel.");
                channel.close(200, "Bye")
            }).map_err(Error::from)
        }).map_err(|err| {
            eprintln!("amqp error: {:?}", err);
        })
    );
}

Dependencies

~13MB
~285K SLoC